<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>Framework: MetaUav.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Framework
   </div>
   <div id="projectbrief">Framework drone</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_meta_uav_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Properties</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">MetaUav.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//  created:    2014/04/29</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">//  filename:   MetaUav.h</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//  author:     Guillaume Sanahuja</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//              Copyright Heudiasyc UMR UTC/CNRS 7253</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">//  version:    $Id: $</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">//  purpose:    meta class for UAV</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">/*********************************************************************/</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#ifndef METAUAV_H</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#define METAUAV_H</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_thread_8h.html">Thread.h</a>&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_uav_chooser_8h.html">UavChooser.h</a>&gt;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_point2_d_8h.html">Point2D.h</a>&gt;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_euler_8h.html">Euler.h</a>&gt;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_point3_d_8h.html">Point3D.h</a>&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">namespace </span>framework {</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keyword">namespace </span>core {</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="keyword">class </span>FrameworkManager;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        <span class="keyword">class </span>Euler;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <span class="keyword">class </span>Point3D;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    }</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keyword">namespace </span>gui {</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keyword">class </span>PushButton;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="keyword">class </span>GridLayout;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="keyword">class </span>Tab;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        <span class="keyword">class </span>DoubleSpinBox;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    }</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keyword">namespace </span>filter {</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keyword">class </span>ControlLaw;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keyword">class </span>NestedSat;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="keyword">class </span>Pid;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keyword">class </span>PidThrust;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="keyword">class </span>TrajectoryGenerator1D;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    }</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keyword">namespace </span>meta {</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="keyword">class </span>MetaDualShock3;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    }</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;}</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">namespace </span>framework</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;{</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="keyword">namespace </span>meta</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;{</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div>
<div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="classframework_1_1meta_1_1_meta_uav.html">   59</a></span>&#160;<span class="keyword">class </span><a class="code" href="classframework_1_1meta_1_1_meta_uav.html">MetaUav</a> : <span class="keyword">public</span> <a class="code" href="classframework_1_1meta_1_1_uav_chooser.html">UavChooser</a>,<span class="keyword">public</span> <a class="code" href="classframework_1_1core_1_1_thread.html">core::Thread</a></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;{</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keyword">enum class</span> AltitudeMode_t {</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            Manual,</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            Custom</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        };</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        AltitudeMode_t <span class="keyword">const</span> &amp;GetAltitudeMode(<span class="keywordtype">void</span>) {</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;            <span class="keywordflow">return</span> altitudeMode;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        }</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="keywordtype">bool</span> SetAltitudeMode(AltitudeMode_t <span class="keyword">const</span> &amp;_altitudeMode);</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keyword">enum class</span> OrientationMode_t {</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            Manual,</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;            Custom</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        };</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        OrientationMode_t <span class="keyword">const</span> &amp;GetOrientationMode(<span class="keywordtype">void</span>) {</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;            <span class="keywordflow">return</span> orientationMode;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        }</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keywordtype">bool</span> SetOrientationMode(OrientationMode_t <span class="keyword">const</span> &amp;_orientationMode);</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keyword">enum class</span> ThrustMode_t {</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;            Default,</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;            Custom</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        };</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        ThrustMode_t <span class="keyword">const</span> &amp;GetThrustMode() {</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;            <span class="keywordflow">return</span> thrustMode;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        }</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        <span class="keywordtype">bool</span> SetThrustMode(ThrustMode_t <span class="keyword">const</span> &amp;_thrustMode);</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keyword">enum class</span> TorqueMode_t {</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            Default,</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            Custom</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        };</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        TorqueMode_t <span class="keyword">const</span> &amp;GetTorqueMode(<span class="keywordtype">void</span>) {</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            <span class="keywordflow">return</span> torqueMode;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        }</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        <span class="keywordtype">bool</span> SetTorqueMode(TorqueMode_t <span class="keyword">const</span> &amp;_torqueMode);</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        <span class="keyword">enum class</span> Event_t {</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            EnteringFailSafeMode,</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            EnteringControlLoop,</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            StartLanding,</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            FinishLanding,</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;            Stopped,</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;            TakingOff,</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            EmergencyStop,</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;            Stabilized, <span class="comment">//as soon as uav is 3cm far from the ground</span></div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;            ZTrajectoryFinished,</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        };</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        <a class="code" href="classframework_1_1meta_1_1_meta_uav.html">MetaUav</a>(<a class="code" href="classframework_1_1core_1_1_framework_manager.html">core::FrameworkManager</a>* parent,std::string name,std::string uav_type,VRPNType_t VRPNType=None,<span class="keywordtype">int</span> VRPNSerialObjectId=0,uint16_t ds3_port=20000,<a class="code" href="classframework_1_1filter_1_1_uav_multiplex.html">filter::UavMultiplex</a> *multiplex=NULL);</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        ~<a class="code" href="classframework_1_1meta_1_1_meta_uav.html">MetaUav</a>();</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        <a class="code" href="classframework_1_1core_1_1_euler.html">core::Euler</a> <span class="keyword">const</span> &amp;GetCurrentAngles(<span class="keywordtype">void</span>) {</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;            <span class="keywordflow">return</span> currentAngles;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        }</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        <a class="code" href="classframework_1_1core_1_1_point3_d.html">core::Point3D</a> <span class="keyword">const</span> &amp;GetCurrentAngularSpeed(<span class="keywordtype">void</span>) {</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;            <span class="keywordflow">return</span> currentAngularSpeed;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        }</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="keyword">protected</span>:</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keywordtype">void</span> Land(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="keywordtype">void</span> TakeOff(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="keywordtype">void</span> EmergencyStop(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classframework_1_1meta_1_1_meta_uav.html#aea630b081555aae3ef4072435a46c527">SignalEvent</a>(Event_t event);</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> AhrsValues(<a class="code" href="classframework_1_1core_1_1_euler.html">core::Euler</a> &amp;angles, <a class="code" href="classframework_1_1core_1_1_point3_d.html">core::Point3D</a> &amp;angularSpeed);</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> AltitudeValues(<span class="keywordtype">float</span> &amp;z,<span class="keywordtype">float</span> &amp;dz);<span class="comment">//in uav coordinate!</span></div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <span class="keywordtype">void</span> EnterFailSafeMode(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        <span class="keywordtype">bool</span> ExitFailSafeMode(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="keywordtype">void</span> FailSafeAhrsValues(<a class="code" href="classframework_1_1core_1_1_euler.html">core::Euler</a> &amp;angles, <a class="code" href="classframework_1_1core_1_1_point3_d.html">core::Point3D</a> &amp;angularSpeed);</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        <span class="keywordtype">void</span> FailSafeAltitudeValues(<span class="keywordtype">float</span> &amp;z,<span class="keywordtype">float</span> &amp;dz);<span class="comment">//in uav coordinate!</span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        <a class="code" href="classframework_1_1gui_1_1_grid_layout.html">gui::GridLayout</a>* GetButtonsLayout(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> ExtraSecurityCheck(<span class="keywordtype">void</span>){};</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> ExtraCheckJoystick(<span class="keywordtype">void</span>){};</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> ExtraCheckPushButton(<span class="keywordtype">void</span>){};</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        <span class="keywordtype">void</span> GetDefaultReferenceAltitude(<span class="keywordtype">float</span> &amp;refAltitude, <span class="keywordtype">float</span> &amp;refVerticalVelocity);</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> GetReferenceAltitude(<span class="keywordtype">float</span> &amp;refAltitude, <span class="keywordtype">float</span> &amp;refVerticalVelocity);</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        <span class="keywordtype">void</span> GetDefaultThrust(<span class="keywordtype">float</span> <span class="keyword">const</span> &amp;refAltitude, <span class="keywordtype">float</span> <span class="keyword">const</span> &amp;refVerticalVelocity, <span class="keywordtype">float</span> &amp;thrust);</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> GetThrust(<span class="keywordtype">float</span> <span class="keyword">const</span> &amp;refAltitude, <span class="keywordtype">float</span> <span class="keyword">const</span> &amp;refVerticalVelocity, <span class="keywordtype">float</span> &amp;thrust);</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="keywordtype">void</span> GetDefaultReferenceAngles(<a class="code" href="classframework_1_1core_1_1_euler.html">core::Euler</a> &amp;refAngles);</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> GetReferenceAngles(<a class="code" href="classframework_1_1core_1_1_euler.html">core::Euler</a> &amp;refAngles);</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        <span class="keywordtype">void</span> GetDefaultTorques(<a class="code" href="classframework_1_1core_1_1_euler.html">core::Euler</a> <span class="keyword">const</span> &amp;refAngles, <a class="code" href="classframework_1_1core_1_1_euler.html">core::Euler</a> &amp;torques);</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> GetTorques(<a class="code" href="classframework_1_1core_1_1_euler.html">core::Euler</a> <span class="keyword">const</span> &amp;refAngles, <a class="code" href="classframework_1_1core_1_1_euler.html">core::Euler</a> &amp;torques);</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        <a class="code" href="classframework_1_1meta_1_1_meta_dual_shock3.html">MetaDualShock3</a>* joy;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <a class="code" href="classframework_1_1gui_1_1_tab.html">gui::Tab</a> *setup_law_tab,*graph_law_tab;</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <span class="keyword">private</span>:</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        <span class="keyword">enum class</span> AltitudeState_t {</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            <a class="code" href="classframework_1_1meta_1_1_meta_uav.html#aedc900a86c6ced9361cfc1d821fbdb20ac23e2b09ebe6bf4cb5e2a9abe85c0be2">Stopped</a>,        </div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;            <a class="code" href="classframework_1_1meta_1_1_meta_uav.html#aedc900a86c6ced9361cfc1d821fbdb20a85916c5f3400cfa25d988f05b6736a94">TakingOff</a>,      </div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;            <a class="code" href="classframework_1_1meta_1_1_meta_uav.html#aedc900a86c6ced9361cfc1d821fbdb20afda22026db89cdc5e88b262ad9424b41">Stabilized</a>,     </div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;            <a class="code" href="classframework_1_1meta_1_1_meta_uav.html#aedc900a86c6ced9361cfc1d821fbdb20a0a0480d215decaf46260e3db52e4dc4c">StartLanding</a>,   </div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            <a class="code" href="classframework_1_1meta_1_1_meta_uav.html#aedc900a86c6ced9361cfc1d821fbdb20a0912358d703c9a28d93a2707b86161b2">FinishLanding</a>   </div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        };</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        AltitudeState_t altitudeState;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        <span class="keywordtype">void</span> ProcessAltitudeFiniteStateMachine();</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        <span class="keywordtype">void</span> ComputeReferenceAltitude(<span class="keywordtype">float</span> &amp;refAltitude, <span class="keywordtype">float</span> &amp;refVerticalVelocity);</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <a class="code" href="classframework_1_1filter_1_1_trajectory_generator1_d.html">filter::TrajectoryGenerator1D</a>* altitudeTrajectory;</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        <a class="code" href="classframework_1_1gui_1_1_double_spin_box.html">gui::DoubleSpinBox</a> *desiredTakeoffAltitude,*desiredLandingAltitude;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        <span class="keywordtype">float</span> groundAltitude; <span class="comment">// effective altitude when the uav leaves the ground</span></div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        <span class="keywordtype">float</span> currentAltitude,currentVerticalSpeed;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        <span class="keywordtype">bool</span> failSafeMode;</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        <span class="keywordtype">void</span> SecurityCheck(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        <span class="keywordtype">void</span> MandatorySecurityCheck(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        <span class="keywordtype">void</span> CheckJoystick();</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        <span class="keywordtype">void</span> GenericCheckJoystick();</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        <span class="keywordtype">void</span> CheckPushButton(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        <span class="keywordtype">void</span> GenericCheckPushButton(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        <span class="keywordtype">void</span> Run(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        <span class="keywordtype">void</span> StopMotors(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        <a class="code" href="classframework_1_1core_1_1_euler.html">core::Euler</a> currentAngles;</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        <a class="code" href="classframework_1_1core_1_1_point3_d.html">core::Point3D</a> currentAngularSpeed;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        <span class="keywordtype">void</span> ComputeReferenceAngles(<a class="code" href="classframework_1_1core_1_1_euler.html">core::Euler</a> &amp;refAngles);</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        <span class="keywordtype">void</span> ComputeThrust(<span class="keywordtype">float</span> <span class="keyword">const</span>&amp;refAltitude, <span class="keywordtype">float</span> <span class="keyword">const</span> &amp;refVerticalVelocity, <span class="keywordtype">float</span> &amp;thrust);</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        <span class="keywordtype">void</span> ComputeTorques(<a class="code" href="classframework_1_1core_1_1_euler.html">core::Euler</a> <span class="keyword">const</span>&amp;refAngles, <a class="code" href="classframework_1_1core_1_1_euler.html">core::Euler</a> &amp;torques);</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;<span class="comment">//        float thrustRef;</span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        <a class="code" href="classframework_1_1gui_1_1_push_button.html">gui::PushButton</a> *button_kill,*button_take_off,*button_land,*button_start_log,*button_stop_log;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        <a class="code" href="classframework_1_1gui_1_1_grid_layout.html">gui::GridLayout</a>* buttonslayout;</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;<span class="comment">//        DefaultLaws_t defaultlaws;</span></div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        AltitudeMode_t altitudeMode;</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        OrientationMode_t orientationMode;</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        ThrustMode_t thrustMode;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        TorqueMode_t torqueMode;</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        <span class="keywordtype">bool</span> flagBatteryLow;</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        <span class="keywordtype">bool</span> flagConnectionLost;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        <span class="keywordtype">bool</span> flagZTrajectoryFinished;</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        <a class="code" href="classframework_1_1filter_1_1_nested_sat.html">filter::NestedSat</a> *u_roll,*u_pitch;</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <a class="code" href="classframework_1_1filter_1_1_pid.html">filter::Pid</a> *u_yaw;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        <a class="code" href="classframework_1_1filter_1_1_pid_thrust.html">filter::PidThrust</a> *u_z;</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;};</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;};</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;};</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;<span class="preprocessor">#endif // METAUAV_H</span></div>
<div class="ttc" id="classframework_1_1core_1_1_thread_html"><div class="ttname"><a href="classframework_1_1core_1_1_thread.html">framework::core::Thread</a></div><div class="ttdoc">Abstract class for a thread. </div><div class="ttdef"><b>Definition:</b> Thread.h:34</div></div>
<div class="ttc" id="classframework_1_1gui_1_1_push_button_html"><div class="ttname"><a href="classframework_1_1gui_1_1_push_button.html">framework::gui::PushButton</a></div><div class="ttdoc">Class displaying a QPushButton on the ground station. </div><div class="ttdef"><b>Definition:</b> PushButton.h:26</div></div>
<div class="ttc" id="classframework_1_1filter_1_1_trajectory_generator1_d_html"><div class="ttname"><a href="classframework_1_1filter_1_1_trajectory_generator1_d.html">framework::filter::TrajectoryGenerator1D</a></div><div class="ttdoc">Class generating a trajectory in 1D. </div><div class="ttdef"><b>Definition:</b> TrajectoryGenerator1D.h:45</div></div>
<div class="ttc" id="classframework_1_1core_1_1_point3_d_html"><div class="ttname"><a href="classframework_1_1core_1_1_point3_d.html">framework::core::Point3D</a></div><div class="ttdoc">Class defining a 3D point. </div><div class="ttdef"><b>Definition:</b> Point3D.h:23</div></div>
<div class="ttc" id="classframework_1_1core_1_1_framework_manager_html"><div class="ttname"><a href="classframework_1_1core_1_1_framework_manager.html">framework::core::FrameworkManager</a></div><div class="ttdoc">Main class of the Framework library. </div><div class="ttdef"><b>Definition:</b> FrameworkManager.h:44</div></div>
<div class="ttc" id="_uav_chooser_8h_html"><div class="ttname"><a href="_uav_chooser_8h.html">UavChooser.h</a></div><div class="ttdoc">Class to construct sensors depending on uav type. </div></div>
<div class="ttc" id="_point2_d_8h_html"><div class="ttname"><a href="_point2_d_8h.html">Point2D.h</a></div><div class="ttdoc">Class defining a 2D point. </div></div>
<div class="ttc" id="classframework_1_1filter_1_1_pid_thrust_html"><div class="ttname"><a href="classframework_1_1filter_1_1_pid_thrust.html">framework::filter::PidThrust</a></div><div class="ttdoc">Class defining a Pid for Thrust. This Pid as an extra offset for compensating gravity. </div><div class="ttdef"><b>Definition:</b> PidThrust.h:33</div></div>
<div class="ttc" id="classframework_1_1meta_1_1_meta_uav_html"><div class="ttname"><a href="classframework_1_1meta_1_1_meta_uav.html">framework::meta::MetaUav</a></div><div class="ttdoc">Meta class for UAV. </div><div class="ttdef"><b>Definition:</b> MetaUav.h:59</div></div>
<div class="ttc" id="classframework_1_1meta_1_1_meta_uav_html_aedc900a86c6ced9361cfc1d821fbdb20afda22026db89cdc5e88b262ad9424b41"><div class="ttname"><a href="classframework_1_1meta_1_1_meta_uav.html#aedc900a86c6ced9361cfc1d821fbdb20afda22026db89cdc5e88b262ad9424b41">framework::meta::MetaUav::AltitudeState_t::Stabilized</a></div></div>
<div class="ttc" id="classframework_1_1meta_1_1_meta_uav_html_aedc900a86c6ced9361cfc1d821fbdb20a0a0480d215decaf46260e3db52e4dc4c"><div class="ttname"><a href="classframework_1_1meta_1_1_meta_uav.html#aedc900a86c6ced9361cfc1d821fbdb20a0a0480d215decaf46260e3db52e4dc4c">framework::meta::MetaUav::AltitudeState_t::StartLanding</a></div></div>
<div class="ttc" id="classframework_1_1core_1_1_euler_html"><div class="ttname"><a href="classframework_1_1core_1_1_euler.html">framework::core::Euler</a></div><div class="ttdoc">Class defining euler angles. </div><div class="ttdef"><b>Definition:</b> Euler.h:24</div></div>
<div class="ttc" id="classframework_1_1filter_1_1_pid_html"><div class="ttname"><a href="classframework_1_1filter_1_1_pid.html">framework::filter::Pid</a></div><div class="ttdoc">Class defining a PID. </div><div class="ttdef"><b>Definition:</b> Pid.h:32</div></div>
<div class="ttc" id="_thread_8h_html"><div class="ttname"><a href="_thread_8h.html">Thread.h</a></div><div class="ttdoc">Abstract class for a thread. </div></div>
<div class="ttc" id="classframework_1_1gui_1_1_tab_html"><div class="ttname"><a href="classframework_1_1gui_1_1_tab.html">framework::gui::Tab</a></div><div class="ttdoc">Class displaying a QTab on the ground station. </div><div class="ttdef"><b>Definition:</b> Tab.h:27</div></div>
<div class="ttc" id="classframework_1_1meta_1_1_meta_uav_html_aedc900a86c6ced9361cfc1d821fbdb20ac23e2b09ebe6bf4cb5e2a9abe85c0be2"><div class="ttname"><a href="classframework_1_1meta_1_1_meta_uav.html#aedc900a86c6ced9361cfc1d821fbdb20ac23e2b09ebe6bf4cb5e2a9abe85c0be2">framework::meta::MetaUav::AltitudeState_t::Stopped</a></div></div>
<div class="ttc" id="classframework_1_1gui_1_1_grid_layout_html"><div class="ttname"><a href="classframework_1_1gui_1_1_grid_layout.html">framework::gui::GridLayout</a></div><div class="ttdoc">Class displaying a QGridLayout on the ground station. </div><div class="ttdef"><b>Definition:</b> GridLayout.h:25</div></div>
<div class="ttc" id="classframework_1_1meta_1_1_meta_uav_html_aea630b081555aae3ef4072435a46c527"><div class="ttname"><a href="classframework_1_1meta_1_1_meta_uav.html#aea630b081555aae3ef4072435a46c527">framework::meta::MetaUav::SignalEvent</a></div><div class="ttdeci">virtual void SignalEvent(Event_t event)</div><div class="ttdoc">Used to signal an event. </div></div>
<div class="ttc" id="classframework_1_1meta_1_1_meta_dual_shock3_html"><div class="ttname"><a href="classframework_1_1meta_1_1_meta_dual_shock3.html">framework::meta::MetaDualShock3</a></div><div class="ttdoc">Classe intégrant la manette MetaDualShock3. </div><div class="ttdef"><b>Definition:</b> MetaDualShock3.h:32</div></div>
<div class="ttc" id="classframework_1_1meta_1_1_uav_chooser_html"><div class="ttname"><a href="classframework_1_1meta_1_1_uav_chooser.html">framework::meta::UavChooser</a></div><div class="ttdoc">Class to construct sensors depending on uav type. </div><div class="ttdef"><b>Definition:</b> UavChooser.h:51</div></div>
<div class="ttc" id="classframework_1_1gui_1_1_double_spin_box_html"><div class="ttname"><a href="classframework_1_1gui_1_1_double_spin_box.html">framework::gui::DoubleSpinBox</a></div><div class="ttdoc">Class displaying a QDoubleSpinBox on the ground station. </div><div class="ttdef"><b>Definition:</b> DoubleSpinBox.h:26</div></div>
<div class="ttc" id="classframework_1_1filter_1_1_uav_multiplex_html"><div class="ttname"><a href="classframework_1_1filter_1_1_uav_multiplex.html">framework::filter::UavMultiplex</a></div><div class="ttdoc">Class defining uav multiplexing. </div><div class="ttdef"><b>Definition:</b> UavMultiplex.h:39</div></div>
<div class="ttc" id="classframework_1_1meta_1_1_meta_uav_html_aedc900a86c6ced9361cfc1d821fbdb20a85916c5f3400cfa25d988f05b6736a94"><div class="ttname"><a href="classframework_1_1meta_1_1_meta_uav.html#aedc900a86c6ced9361cfc1d821fbdb20a85916c5f3400cfa25d988f05b6736a94">framework::meta::MetaUav::AltitudeState_t::TakingOff</a></div></div>
<div class="ttc" id="classframework_1_1meta_1_1_meta_uav_html_aedc900a86c6ced9361cfc1d821fbdb20a0912358d703c9a28d93a2707b86161b2"><div class="ttname"><a href="classframework_1_1meta_1_1_meta_uav.html#aedc900a86c6ced9361cfc1d821fbdb20a0912358d703c9a28d93a2707b86161b2">framework::meta::MetaUav::AltitudeState_t::FinishLanding</a></div></div>
<div class="ttc" id="_point3_d_8h_html"><div class="ttname"><a href="_point3_d_8h.html">Point3D.h</a></div><div class="ttdoc">Class defining a 3D point. </div></div>
<div class="ttc" id="classframework_1_1filter_1_1_nested_sat_html"><div class="ttname"><a href="classframework_1_1filter_1_1_nested_sat.html">framework::filter::NestedSat</a></div><div class="ttdoc">Class defining a PID with saturations. </div><div class="ttdef"><b>Definition:</b> NestedSat.h:42</div></div>
<div class="ttc" id="_euler_8h_html"><div class="ttname"><a href="_euler_8h.html">Euler.h</a></div><div class="ttdoc">Class defining euler angles. </div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d9f696bd07998dbcfc5b49e19dc5f66d.html">igep</a></li><li class="navelem"><a class="el" href="dir_7775cfc2302e50905e8c794823e78d65.html">uav_lib</a></li><li class="navelem"><a class="el" href="dir_3d8b3ef72b6bddf04a7da37c46c6171b.html">framework</a></li><li class="navelem"><a class="el" href="dir_ced5e5b63a4f31796691615aae494bcc.html">Meta</a></li><li class="navelem"><a class="el" href="dir_63a5a607d66199e87f82dbff7127a647.html">src</a></li><li class="navelem"><b>MetaUav.h</b></li>
    <li class="footer">Generated on Fri Feb 5 2016 14:55:05 for Framework by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.7 </li>
  </ul>
</div>
</body>
</html>
